Subject: RE: bug#41821: 28.0.50; read-directory-name in vc commands should provide defaults from projects

From: Drew Adams <[email-masked]>
Date: Fri, 3 Jul 2020 16:05:56 +0000 (UTC)

> > But it's for a default value (one you can insert using M-n, or not).
> > Most users won't even notice this.
> 
> You assume that most users don't know about or use M-n?  I do it all
> the time, and would like to think others do as well.

OT -

Dunno about "most", but I suspect "many", yes.

`M-n' is super-useful, and I'm guessing that many
users, ignorant of it, fairly often go to the
trouble of typing what's in fact the default value.

Dunno what might be a good solution to this lack
of discovery.

I've taken one approach that I hope helps a bit,
but it too suffers from discoverability.  Pretty
much anything that doesn't, by default, put the
default value in the minibuffer suffers from some
difficulty of discovery.

What I do in Icicles is this, FWIW (again, not a
panacea):

When option `icicle-default-value' is non-nil (it's
nil by default, hence a discovery problem still),
and the INITIAL-INPUT arg of minibuffer-reading
functions is nil or "", the DEFAULT-VALUE arg can
be inserted in the minibuffer as input.

(You can clear the minibuffer anytime with `M-k'.)

Particular non-nil values determine placement of
point wrt the inserted value, and whether the value
is automatically selected (useful with
`delete-selection-mode').

https://www.emacswiki.org/emacs/Icicles_-_Customization_and_General_Tips#icicle-default-value

I mention this because I think that `M-n' is likely
underused because of ignorance.  Other ways to make
it known could help.  Inserting it automatically is
not necessarily the best way.

We could, say, until you do something to remove the
nag, append something to minibuffer prompts, to
point out `M-n'.  Or we could provide a help key
that shows *Help* with info about `M-n', `M-p', etc.
Dunno what might help new users the most without
bothering others.